package inria.meije.rc.sugarcubes;

public class IODecl extends EventDecl
{
    protected String actualName;
    protected JavaStringExpression actualNameExp = null;
    protected boolean start;

    public IODecl(String localName,String actualName,Instruction body){ 
        this(localName,new JavaStringValue(actualName),body); 
    }
    public IODecl(String localName,JavaStringExpression actualName,Instruction body){ 
        super(localName,body);
        actualNameExp = actualName; 
    }

    public String toString(){ 
        return "inputoutput "+eventName+" is "+actualNameExp+" in "+body+" end";
    }
    protected Instruction rest(){ 
        return new IODecl(eventName,actualNameExp,body.residual()); 
    }
    protected void firstActivation(Context context){ 
        actualName = actualNameExp.evaluate(context.currentLink());
        actualNameExp = new JavaStringValue(actualName);
        super.firstActivation(context);
    }
    protected void setInput(Domain domain){
        local = local ||(start = domain.isGenerated(actualName));
    }
    protected byte activation(Context context){ 
        setInput((Domain)context);
        byte res = super.activation(context);
        setOutput((Domain)context);
        return res;
    }
    protected void setOutput(Domain domain){
        if(!start && local) domain.generate(actualName);
    }
}
