package inria.meije.rc.sugarcubes;

abstract public class InstructionImpl implements Instruction, ReturnCodes
{
    protected boolean terminated = false;
    protected boolean firstActivation = true;

    public boolean isTerminated(){ return terminated; }
    abstract protected byte activation(Context context);
    protected void firstActivation(Context context){ firstActivation = false; }
    public byte activ(Context context){
        if (terminated) return TERM;
        if (firstActivation) firstActivation(context);
        byte res = activation(context);
        if (res == TERM) lastActivation(context);
        return res;
    }
    protected void lastActivation(Context context){ terminated = true; }
    public String toString(){ return ""; }
    protected Instruction rest(){ return (Instruction)clone(); }
    public Instruction residual(){
        if (terminated) return new Nothing(); 
        return rest();
    }
    public Object clone(){
        try{ return (Instruction)super.clone(); }
        catch (CloneNotSupportedException e){
            throw new InternalError(e.toString());
        } 
    }
    public void freeze(Context context){}
    public void notifyWarmUpToJava(Context context){}
    public void notifyFreezeToJava(Context context) {}
    public void notifyTerminationToJava(Context context){}
}
