package inria.meije.rc.sugarcubes;

public class LinkImpl extends UnaryInstruction implements Link
{
    protected Object javaObject = null;
    protected JavaObjectExpression joe = null;
    protected JavaInstruction onTerminate, onFreeze, onWarmUp;
    protected Link superLink,trueLink = this;

    public LinkImpl(JavaObjectExpression obj,Instruction i
                    ,JavaInstruction fin,JavaInstruction f,JavaInstruction w){
        joe = obj; body = i; onTerminate = fin;onFreeze = f;onWarmUp = w;
    }
    public LinkImpl(Object obj,Instruction i){
        this(new JavaObjectValue(obj),i,new JavaEmptyInstruction()
                    ,new JavaEmptyInstruction(),new JavaEmptyInstruction());
    }

    public Object javaObject(){
        return javaObject;
    }
    public Link superLink(){ return superLink; }
    protected void setCube(Cube cube){ trueLink = cube; }
    public String toString(){
        return "link "+body+" on freeze "+onFreeze+ " on warm up "+onWarmUp+" on terminate "+onTerminate+" end";
    }
    protected Instruction rest(){
        return new LinkImpl(joe,body.residual(),onTerminate,onFreeze,onWarmUp);
    }
    protected void firstActivation(Context context){
        javaObject = joe.evaluate(context.currentLink());
        joe = new JavaObjectValue(javaObject);
        super.firstActivation(context);
    }
    protected byte activation(Context context){
        superLink = context.currentLink();
        context.setCurrentLink(trueLink);
        byte res = body.activ(context);
        context.setCurrentLink(superLink);
        return res;
    }
    protected void lastActivation(Context context){
        onTerminate.execute(trueLink);
        super.lastActivation(context);
    }
    public void notifyTerminationToJava(Context context){
        superLink = context.currentLink();
        context.setCurrentLink(trueLink);
        body.notifyTerminationToJava(context);
        onTerminate.execute(trueLink);
        context.setCurrentLink(superLink);
    }
    public void notifyFreezeToJava(Context context){
        superLink = context.currentLink();
        context.setCurrentLink(trueLink);
        body.notifyFreezeToJava(context);
        onFreeze.execute(trueLink);
        context.setCurrentLink(superLink);
    }
    public void notifyWarmUpToJava(Context context){
        body.notifyWarmUpToJava(context);
        body = new Seq(new JavaAtom(onWarmUp),body);
    }
}
