package inria.meije.rc.sugarcubes;

public class ShellImpl extends UnaryInstruction implements Shell,NamedInstruction
{
    protected String name = "noname";
    protected JavaStringExpression nameExp = null;

    public ShellImpl(JavaStringExpression n,Instruction i){ nameExp = n;body = i; }
    public ShellImpl(String n,Instruction i){ this(new JavaStringValue(n),i); }

    public String name(){ return name; }
    public void add(Instruction inst){ body = new Merge(body,inst); }
    public String toString(){
        return "shell "+nameExp+" "+body+" end";
    }
    public Instruction body(){ return body; }
    protected Instruction rest(){ 
        return new ShellImpl(nameExp,body.residual());
    }
    protected void firstActivation(Context context){
        name = nameExp.evaluate(context.currentLink());
        nameExp = new JavaStringValue(name);
        context.registerShell(name,this);
        super.firstActivation(context);
    }
    protected void lastActivation(Context context){
        context.removeShell(name);
        super.lastActivation(context);
    }
    public void notifyFreezeToJava(Context context){
        super.notifyFreezeToJava(context);
        context.removeShell(name);
    }
    public void notifyTerminationToJava(Context context){
        super.notifyTerminationToJava(context);
        context.removeShell(name);
    }
}
